/*
 * CommandLineStatusIndicator.hpp
 *
 *  Created on: May 8, 2010
 *      Author: heber
 */

#ifndef COMMANDLINESTATUSINDICATOR_HPP_
#define COMMANDLINESTATUSINDICATOR_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include "CodePatterns/Observer/Observer.hpp"

namespace MoleCuilder {
  class ActionStatusList;
}

class Observable;

class CommandLineStatusIndicator : public Observer
{
public:
  CommandLineStatusIndicator();
  virtual ~CommandLineStatusIndicator();

  void update(Observable *subject);
  void subjectKilled(Observable *subject);
  void recieveNotification(Observable *_publisher, Notification *_notification);

private:
  void displayStatusMessage() const;

private:
  //!> reference to the StatusList we are signed on
  MoleCuilder::ActionStatusList& StatusList;
  //!> indicates whether we are currently signed on
  bool StatusList_signedOn;
};

#endif /* COMMANDLINESTATUSINDICATOR_HPP_ */
